(** Church-Style Terms for System F omega: printing. *)

type clos = Clos.surr * Clos.surr * Exp.exp (** Church-style closures *)


(* unused

(** Operations on Church-style cloures *)

val tmAbs' : clos -> Clos.clos
*)


(** Type inference for Church-style terms *)

val infer : Clos.clos * Clos.surr -> Exp.exp
(** [infer (cL, (thR, gR)) = tau] *)

val check : Clos.clos * Clos.clos * Exp.exp -> unit
(** [check (cL, cR, mkType/mkKind) = ()] *)

val checkType : Clos.clos -> unit


(** Printing Church-style terms *)

val toString : clos -> string
(** [toString ((thL, gL), (thR, gR), e)] *)


(** Eta-reduction normal forms for Church terms *)

val etanf : clos -> Exp.exp
