(* sig CLOS *)

(** Closures: top-level intro functions, printing. *)

open Surr   

type surr = env * cxt
type clos = surr * Exp.exp
	      
val empty : surr
val push     : string * preExp * surr -> surr
val pushTmVar: string * (cxt * Exp.exp) * surr -> surr
val pushTyVar: string * Exp.exp * surr -> surr
val push'    : string * surr -> surr

(* do not care for unique names: *)
val pushLit' : string * surr -> surr
  
exception UnknownIdent of string
  
val index : surr * string -> int
  
val close : Exp.exp -> clos
  
val toString  : clos -> string 
val toString' : int * clos -> string 

