(** A parser for command line arguments *)

exception Error of string

type option =
    Num of int           (** --opt=<num>                 *)
  | List of string list  (** --opt=<string>,...,<string> *)
  | Nothing              (** --opt                       *)
    
type arg =
    ShortOption of string         (** -o             *)
  | LongOption of string * option (** --opt=value    *)
  | File of string                (** no leading '-' *)


val unrecognizedOption : string -> 'a
val wrongSyntaxInOption : string -> 'a

val parseArg : string -> arg
