(* struct Global *)
(** Global contexts and environments. *)

open Surr

(*
let tmcxt = ref (cxt_empty)
let tycxt = ref (cxt_empty)
*)
let tmenv = ref (env_empty)
let tyenv = ref (env_empty)

(*
let tmCxt() = !tmcxt
let tyCxt() = !tycxt
*)
let tmCxt() = cxt_empty
let tyCxt() = cxt_empty
let tmEnv() = !tmenv
let tyEnv() = !tyenv

let tmSurr () = (tmEnv(), tmCxt())
let tySurr () = (tyEnv(), tyCxt())
let kiSurr () = (env_empty, cxt_empty)

let closeTm (t) = (tmSurr (), t)
let closeTy (tau) = (tySurr (), tau)
let closeKi (kappa) = (Clos.close (kappa))

let addTmDecl (x, tau)    = tmenv := env_pushDecl (x, tau, !tmenv)
let addTyDecl (x, kappa)  = tyenv := env_pushDecl (x, kappa, !tyenv)
let addTmDef  (x, tau, t) = tmenv := env_pushDef  (x, tau, t, false, !tmenv)
let addTyDef  (x, kappa, tau, strict) =  
  tyenv := env_pushDef (x, kappa, tau, strict, !tyenv)
