(** Unification *)

open Exp
open Surr

(** Options *)

(* val indent : int    indentation for trace -- moved to output.mli*)

type spineCl

exception Fail of string  (** unification failed *)
(* exception Error of string (** real exception: internal error *) moved to Output *)

(** [isFlexPlusArgs ((th, g), tau)] returns [true] 
  iff [tau] = ?X sigma_0 ... sigma_n *)
val isFlexPlusArgs : Clos.clos -> bool

val unify : int * (env * cxt) * exp * exp * exp -> unit
(** [unify (ind, (theta, gamma), sigma, tau, kappa) = ()]
if [gamma |- sigma = tau : kappa]
 *)

val subType : int * env -> Church.clos -> exp * exp -> cxt * (env * exp)
(** [subType (ind, thStop) ((thL, gL), (thR, gR), e) (sigma, tau) = (gR', (thR',
e'))]

if [thL, gL, gR |- (thR, e) : sigma <= (thR', e') : tau]

[subType] checks whether [sigma] is a subtype of [tau], introducing
and instantiating EVars in(to) [thR] on the fly to obtain [thR'].
From the input Church term closure [((thL, gL), (thR, gR), e)] of type
[sigma] it computes a Church term closure [((thL, gL), (thR', gR),
e')] of type [tau].

The extended context [gR'] serves to check subterms of e.
*)

val spineToString : spineCl -> string
